#include <stdio.h>
#include <stdlib.h>
#include <math.h>
   
int main ()
{
	double* y;
	double x,S,S1,tay,h,A0,A1,emax;
	double e,A;
	int Nx,Nt,i,j;
	FILE* F;

	Nx=36;
	Nt=1500;
	
	F=fopen("2","w+t");
	h=M_PI/(Nx-1)/3;
	tay=h*h;
	y=(double*) malloc(Nx*Nt*sizeof(double));
	fprintf(stderr,"tay=%lf\nh=%.10lf\nT=%lf\n",tay,h,tay*Nt);
	
	S=0;
	for (i=0;i<Nx;i++)
	{
		x=cos(3*i*h);
		y[i]=x;
		S+=x;
//		fprintf(stderr,"S=%lf\n",S);
		fprintf(F,"%lf\t%lf\t%.10lf\n",i*h,0.0,x);
	}
	S-=x+1;
//	fprintf(stderr,"%lf",(Nx-1)*h-M_PI/3);

	for(j=1;j<Nt;j++)
	{
		A=1;
		e=0.001;
		S1=S+1;
		emax=pow(10,-20);
		while((S1-S)*(S1-S)>emax)
		{		
			y[Nx*j]=A;
			y[Nx*j+1]=A;
			S1=0;
			for(i=2;i<Nx;i++)
			{
//				fprintf(stderr,"%d\t%d\n",i,j);
				x=h*h/tay*(y[Nx*j+i-1]-y[Nx*(j-1)+i-1])+2*y[Nx*j+i-1]-y[Nx*j+i-2];
				y[Nx*j+i]=x;
//				fprintf(stderr,"y[Nx*j+i-1]=%lf\ny[Nx*(j-1)+i-1]=%lf\ny[Nx*j+i-2]=%lf\nx=%lf\n\n",y[Nx*j+i-1],y[Nx*(j-1)+i-1],y[Nx*j+i-2],x);
				S1+=x;
//				fprintf(stderr,"S1=%lf\n",S1);
//				fprintf(F,"%lf\t%lf\t%.10lf\n",-i*h,j*tay,x);
			}
			S1-=x;
			S1+=A;
//			fprintf(stderr,"\n\nS=%lf\nS1=%lf\nA=%.20lf\ne=%.35lf\n",S,S1,A,e);
			if (A0==A) e=e/10;
			if (e<pow(10,-30))
			{
				emax=emax*10;
				e=e*10;
			}
			A0=A1;
			A1=A;
			if (S1>S) A-=e; else A+=e;
		}
//		fprintf(stderr,"A=%.50lf\ne=%.50lf\n",A,e);
		for(i=0;i<Nx;i++) 
		{
				fprintf(F,"%lf\t%lf\t%.10lf\n",i*h,j*tay,y[Nx*j+i]);
		}
//		fprintf(stderr,"%lf=%lf\n",y[Nx*j+Nx-1],y[Nx*j+Nx-2]);
		
	}
	
	return 0;
}
